diff --git a/test/yum-release-test.sh b/test/yum-release-test.sh
index fba02c5..a9270e2 100755
--- a/test/yum-release-test.sh
+++ b/test/yum-release-test.sh
@@ -73,7 +73,7 @@ if [ ! -d $WORKDIR/usr/bin ]; then
   "${RPM[@]}" -q vim-minimal > /dev/null
   if [ "X$?" == "X0" ] ; then echo " OK"; else echo " FAILED"; fi
 else
-  echo Ommiting base install
+  echo Omitting base install
 fi
 
 #"${YUMUPDATES[@]}" list updates
diff --git a/utils.py b/utils.py
old mode 100644
new mode 100755
index ced6ba0..dbcd605
--- a/utils.py
+++ b/utils.py
@@ -13,6 +13,9 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
+"""Various utility functions, and a utility class."""
+
+import os
 import sys
 import time
 import exceptions
@@ -21,14 +24,23 @@ import yum
 from cli import *
 from yum import Errors
 from yum import _
-from yum.i18n import utf8_width
+from yum.i18n import utf8_width, exception2msg
 from yum import logginglevels
 from optparse import OptionGroup
 
 import yum.plugins as plugins
 from urlgrabber.progress import format_number
 
+try:
+    _USER_HZ = os.sysconf(os.sysconf_names['SC_CLK_TCK'])
+except (AttributeError, KeyError):
+    # Huh, non-Unix platform? Or just really old?
+    _USER_HZ = 100
+
 def suppress_keyboard_interrupt_message():
+    """Change settings so that nothing will be printed to the
+    terminal after an uncaught :class:`exceptions.KeyboardInterrupt`.
+    """
     old_excepthook = sys.excepthook
 
     def new_hook(type, value, traceback):
@@ -40,10 +52,22 @@ def suppress_keyboard_interrupt_message():
     sys.excepthook = new_hook
 
 def jiffies_to_seconds(jiffies):
-    Hertz = 100 # FIXME: Hack, need to get this, AT_CLKTCK elf note *sigh*
-    return int(jiffies) / Hertz
+    """Convert a number of jiffies to seconds. How many jiffies are in a second
+    is system-dependent, e.g. 100 jiffies = 1 second is common.
+
+    :param jiffies: a number of jiffies
+    :return: the equivalent number of seconds
+    """
+    return int(jiffies) / _USER_HZ
 
 def seconds_to_ui_time(seconds):
+    """Return a human-readable string representation of the length of
+    a time interval given in seconds.
+
+    :param seconds: the length of the time interval in seconds
+    :return: a human-readable string representation of the length of
+    the time interval
+    """
     if seconds >= 60 * 60 * 24:
         return "%d day(s) %d:%02d:%02d" % (seconds / (60 * 60 * 24),
                                            (seconds / (60 * 60)) % 24,
@@ -55,6 +79,12 @@ def seconds_to_ui_time(seconds):
     return "%02d:%02d" % ((seconds / 60), seconds % 60)
 
 def get_process_info(pid):
+    """Return information about a process taken from
+    /proc/*pid*/status, /proc/stat/, and /proc/*pid*/stat.
+
+    :param pid: the process id number
+    :return: a dictionary containing information about the process
+    """
     if not pid:
         return
 
@@ -63,12 +93,6 @@ def get_process_info(pid):
     except ValueError, e:
         return
         
-    # Maybe true if /proc isn't mounted, or not Linux ... or something.
-    if (not os.path.exists("/proc/%d/status" % pid) or
-        not os.path.exists("/proc/stat") or
-        not os.path.exists("/proc/%d/stat" % pid)):
-        return
-
     ps = {}
     for line in open("/proc/%d/status" % pid):
         if line[-1] != '\n':
@@ -83,30 +107,54 @@ def get_process_info(pid):
         return
     if 'vmsize' not in ps:
         return
-    boot_time = None
-    for line in open("/proc/stat"):
-        if line.startswith("btime "):
-            boot_time = int(line[len("btime "):-1])
-            break
+    boot_time = get_boot_time()
     if boot_time is None:
         return
-    ps_stat = open("/proc/%d/stat" % pid).read().split()
-    ps['utime'] = jiffies_to_seconds(ps_stat[13])
-    ps['stime'] = jiffies_to_seconds(ps_stat[14])
-    ps['cutime'] = jiffies_to_seconds(ps_stat[15])
-    ps['cstime'] = jiffies_to_seconds(ps_stat[16])
-    ps['start_time'] = boot_time + jiffies_to_seconds(ps_stat[21])
+    ps.update(get_process_time(pid, boot_time))
+    return ps
+
+
+def get_boot_time():
+    for line in open("/proc/stat"):
+        if line.startswith("btime "):
+            return int(line[len("btime "):-1])
+
+
+def get_process_time(pid, boot_time):
+    ps = {}
+    ps_stat = open("/proc/%d/stat" % pid).read().strip()
+    # Filename of the executable might contain spaces, so we throw it away
+    ps_stat = ps_stat[ps_stat.rfind(')') + 2:].split()
+    ps['utime'] = jiffies_to_seconds(ps_stat[11])
+    ps['stime'] = jiffies_to_seconds(ps_stat[12])
+    ps['cutime'] = jiffies_to_seconds(ps_stat[13])
+    ps['cstime'] = jiffies_to_seconds(ps_stat[14])
+    ps['start_time'] = boot_time + jiffies_to_seconds(ps_stat[19])
     ps['state'] = {'R' : _('Running'),
                    'S' : _('Sleeping'),
                    'D' : _('Uninterruptible'),
                    'Z' : _('Zombie'),
                    'T' : _('Traced/Stopped')
-                   }.get(ps_stat[2], _('Unknown'))
+                   }.get(ps_stat[0], _('Unknown'))
                    
     return ps
 
 def show_lock_owner(pid, logger):
-    ps = get_process_info(pid)
+    """Output information about another process that is holding the
+    yum lock.
+
+    :param pid: the process id number of the process holding the yum
+       lock
+    :param logger: the logger to output the information to
+    :return: a dictionary containing information about the process.
+       This is the same as the dictionary returned by
+       :func:`get_process_info`.
+    """
+    try:
+        ps = get_process_info(pid)
+    except IOError, e:
+        logger.critical("%s", exception2msg(e))
+        ps = None
     if not ps:
         return None
 
@@ -129,28 +177,9 @@ def show_lock_owner(pid, logger):
     return ps
 
 
-def exception2msg(e):
-    """ DIE python DIE! Which one works:
-        to_unicode(e.value); unicode(e); str(e); 
-        Call this so you don't have to care. """
-    try:
-        return to_unicode(e.value)
-    except:
-        pass
-
-    try:
-        return unicode(e)
-    except:
-        pass
-
-    try:
-        return str(e)
-    except:
-        pass
-    return "<exception failed to convert to text>"
-
-
 class YumUtilBase(YumBaseCli):
+    """A class to extend the yum cli for utilities."""
+    
     def __init__(self,name,ver,usage):
         YumBaseCli.__init__(self)
         self._parser = YumOptionParser(base=self,utils=True,usage=usage)
@@ -167,11 +196,22 @@ class YumUtilBase(YumBaseCli):
             self.run_with_package_names.add("yum-utils")
 
     def exUserCancel(self):
+        """Output a message stating that the operation was cancelled
+        by the user.
+
+        :return: the exit code
+        """
         self.logger.critical(_('\n\nExiting on user cancel'))
         if self.unlock(): return 200
         return 1
 
     def exIOError(self, e):
+        """Output a message stating that the program is exiting due to
+        an IO exception.
+
+        :param e: the IO exception
+        :return: the exit code
+        """
         if e.errno == 32:
             self.logger.critical(_('\n\nExiting on Broken Pipe'))
         else:
@@ -180,10 +220,13 @@ class YumUtilBase(YumBaseCli):
         return 1
 
     def exPluginExit(self, e):
-        '''Called when a plugin raises PluginYumExit.
+        """Called when a plugin raises
+           :class:`yum.plugins.PluginYumExit`.  Log the plugin's exit
+           message if one was supplied.
 
-        Log the plugin's exit message if one was supplied.
-        ''' # ' xemacs hack
+        :param e: the exception
+        :return: the exit code
+        """ # ' xemacs hack
         exitmsg = exception2msg(e)
         if exitmsg:
             self.logger.warn('\n\n%s', exitmsg)
@@ -191,11 +234,20 @@ class YumUtilBase(YumBaseCli):
         return 1
 
     def exFatal(self, e):
+        """Output a message stating that a fatal error has occurred.
+
+        :param e: the exception
+        :return: the exit code
+        """
         self.logger.critical('\n\n%s', exception2msg(e))
         if self.unlock(): return 200
         return 1
         
     def unlock(self):
+        """Release the yum lock.
+
+        :return: the exit code
+        """
         try:
             self.closeRpmDB()
             self.doUnlock()
@@ -205,34 +257,31 @@ class YumUtilBase(YumBaseCli):
         
         
     def getOptionParser(self):
+        """Return the :class:`cli.YumOptionParser` for this object.
+
+        :return: the :class:`cli.YumOptionParser` for this object
+        """
         return self._parser        
 
     def getOptionGroup(self):
-        """ Get an option group to add non inherited options"""
+        """Return an option group to add non inherited options.
+
+        :return: a :class:`optparse.OptionGroup` for adding options
+           that are not inherited from :class:`YumBaseCli`.
+        """
         return self._option_group    
     
-    def waitForLock(self):
-        lockerr = ""
-        while True:
-            try:
-                self.doLock()
-            except Errors.LockError, e:
-                if exception2msg(e) != lockerr:
-                    lockerr = exception2msg(e)
-                    self.logger.critical(lockerr)
-                if not self.conf.exit_on_lock:
-                    self.logger.critical("Another app is currently holding the yum lock; waiting for it to exit...")  
-                    show_lock_owner(e.pid, self.logger)
-                    time.sleep(2)
-                else:
-                    raise Errors.YumBaseError, _("Another app is currently holding the yum lock; exiting as configured by exit_on_lock")
-            else:
-                break
-        
     def _printUtilVersion(self):
         print "%s - %s (yum - %s)" % (self._utilName,self._utilVer,yum.__version__)
         
     def doUtilConfigSetup(self,args = sys.argv[1:],pluginsTypes=(plugins.TYPE_CORE,)):
+        """Parse command line options, and perform configuration.
+
+        :param args: list of arguments to use for configuration
+        :param pluginsTypes: a sequence specifying the types of
+           plugins to load
+        :return: a dictionary containing the values of command line options
+        """
         # Parse only command line options that affect basic yum setup
         opts = self._parser.firstParse(args)
 
@@ -305,8 +354,9 @@ class YumUtilBase(YumBaseCli):
         return opts
 
     def doUtilYumSetup(self):
-        """do a default setup for all the normal/necessary yum components,
-           really just a shorthand for testing"""
+        """Do a default setup for all the normal or necessary yum components;
+           this method is mostly just used for testing.
+        """
         # FIXME - we need another way to do this, I think.
         try:
             self.waitForLock()
@@ -319,6 +369,11 @@ class YumUtilBase(YumBaseCli):
             sys.exit(1)
 
     def doUtilBuildTransaction(self, unfinished_transactions_check=True):
+        """Build the transaction.
+
+        :param unfinished_transactions_check: whether to check if an
+           unfinished transaction has been saved
+        """
         try:
             (result, resultmsgs) = self.buildTransaction(unfinished_transactions_check = unfinished_transactions_check)
         except plugins.PluginYumExit, e:
@@ -361,6 +416,7 @@ class YumUtilBase(YumBaseCli):
         self.verbose_logger.log(logginglevels.INFO_2, _('\nDependencies Resolved'))
         
     def doUtilTransaction(self):
+        """Perform the transaction."""
 
         try:
             return_code = self.doTransaction()
diff --git a/yum-cron/Makefile b/yum-cron/Makefile
new file mode 100644
index 0000000..3997b4a
--- /dev/null
+++ b/yum-cron/Makefile
@@ -0,0 +1,25 @@
+all:
+	echo "Nothing to do"
+
+clean:
+	rm -f *~
+
+install: install-$(INIT)
+
+install-systemd: install-common
+	install -D -m 644 yum-cron.service $(DESTDIR)/$(UNITDIR)/yum-cron.service
+
+install-sysv: install-common
+	install -D -m 755 yum-cron.sysvinit $(DESTDIR)/etc/rc.d/init.d/yum-cron
+
+install-common:
+	mkdir -p $(DESTDIR)/etc/cron.hourly
+	mkdir -p $(DESTDIR)/etc/cron.daily
+	mkdir -p $(DESTDIR)/etc/rc.d/init.d
+	mkdir -p $(DESTDIR)/usr/sbin
+# Install as 0yum-*.cron so it runs before items like
+# manpage update, mlocate, and prelink
+	install -D -m 755 yum-daily.cron.sh $(DESTDIR)/etc/cron.daily/0yum-daily.cron
+	install -D -m 755 yum-security.cron.sh $(DESTDIR)/etc/cron.daily/0yum-security.cron
+	install -D -m 755 yum-hourly.cron.sh $(DESTDIR)/etc/cron.hourly/0yum-hourly.cron
+	install -D -m 755 yum-cron.py $(DESTDIR)/usr/sbin/yum-cron
diff --git a/yum-cron/TODO b/yum-cron/TODO
new file mode 100644
index 0000000..28e1964
--- /dev/null
+++ b/yum-cron/TODO
@@ -0,0 +1,19 @@
+Logging:
+- Add basic syslog support (success or failure; number of updates)
+
+Documentation:
+- Write a man page
+- Write a readme file
+
+Mail:
+- Use a different subject for success and failure mail
+- Make receiving mail when nothing happens optional
+
+General:
+- Break out check-updates and download-updates into their own actions;
+  move that logic to the cron scripts
+- Re-do the lockfile bit so failures can be reported without resorting to
+  relying on cron's output handler.
+- Figure out what to do with systemd
+- Update rpm, glibc, yum, python, specially?
+- Check if we're running as root; exit nicely.
